Author: Apollon Oikonomopoulos <apoikos@debian.org>
Description: Fix option_set.count() for untyped enum classes
 Kernighan's bit-counting algorithm works for unsigned integers only. As of
 C++11, an enum class without a specific type qualifier is backed by a signed
 integer, which leads to option_set.count() entering an endless loop. Fix this
 by always casting _value to the respective unsigned type.
Bug-Debian: https://bugs.debian.org/905463
Last-Update: 2018-08-22
Forwarded: no (further investigation needed)
diff --git a/util/inc/leatherman/util/option_set.hpp b/util/inc/leatherman/util/option_set.hpp
index 60470ab..9f78ca1 100644
--- a/util/inc/leatherman/util/option_set.hpp
+++ b/util/inc/leatherman/util/option_set.hpp
@@ -147,7 +147,8 @@ namespace leatherman { namespace util {
         size_t count() const
         {
             // Do a simple bit count
-            value_type bits = _value;
+            typedef typename std::make_unsigned<T>::type bits_type;
+            bits_type bits = _value;
             size_t total = 0;
             for (; bits != 0; ++total)
             {
